using System;

namespace WINS
{
    public class Utils
    {
        internal static void Publish(string machine, string ipAddress)
        {
            string keyName = string.Format(@"Comm\Tcpip\Hosts\{0}", machine);

            string[] ipAddressParts = ipAddress.Split('.');
            byte[] ipAddressPartsInt = new byte[4];

            for (int index = 0; index < 4; index++)
            {
                ipAddressPartsInt[index] = Convert.ToByte(int.Parse(ipAddressParts[index]));
            }

            Microsoft.Win32.RegistryKey registryKey = null;
            try
            {
                registryKey = Microsoft.Win32.Registry.LocalMachine.OpenSubKey(keyName);
            }
            finally
            {
                registryKey = Microsoft.Win32.Registry.LocalMachine.CreateSubKey(keyName);
            }

            if (registryKey != null)
            {
                registryKey.SetValue("ipaddr", ipAddressPartsInt, Microsoft.Win32.RegistryValueKind.Binary);
                registryKey.SetValue("ExpireTime", BitConverter.GetBytes(DateTime.Now.AddDays(1).ToFileTimeUtc()), Microsoft.Win32.RegistryValueKind.Binary);

                registryKey.Close();
            }
        }
   }
}