﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlServerCe;
using System.IO;

namespace Librairie
{
    public class Utils
    {
        public static DataSet SQLServer2008(string chaineConnexion, decimal prixMini, decimal prixMaxi)
        {
            DataSet monDataSet = new DataSet();

            SqlConnection maSqlConnection = new SqlConnection(chaineConnexion);
            maSqlConnection.Open();

            SqlCommand maSqlCommand = maSqlConnection.CreateCommand();
            maSqlCommand.CommandText = "ListeLivres";
            maSqlCommand.CommandType = CommandType.StoredProcedure;

            maSqlCommand.Parameters.AddWithValue("@PrixMini", prixMini);
            maSqlCommand.Parameters.AddWithValue("@PrixMaxi", prixMaxi);

            SqlDataAdapter monSqlDataAdapter = new SqlDataAdapter(maSqlCommand);
            monSqlDataAdapter.Fill(monDataSet, "ListeDesLivres");

            maSqlConnection.Close();

            return monDataSet;
        }

        public static void Synchroniser(string sdfFile)
        {
            SqlCeReplication maSqlCeReplication = new SqlCeReplication();

            maSqlCeReplication.InternetUrl = @"http://win2008-belaud/SQLCE/sqlcesa35.DLL/sqlcesa35.dll";
            maSqlCeReplication.Publisher = @"WIN2008-BELAUD\SQL2008";
            maSqlCeReplication.PublisherDatabase = @"bMSPress";
            maSqlCeReplication.PublisherSecurityMode = SecurityType.NTAuthentication;
            maSqlCeReplication.Publication = @"Publication MSPress";
            maSqlCeReplication.Subscriber = @"Subscription MSPress";
            maSqlCeReplication.SubscriberConnectionString = string.Format(@"Data Source={0}", sdfFile);

            if (!File.Exists(sdfFile))
            {
                maSqlCeReplication.AddSubscription(AddOption.CreateDatabase);
            }

            maSqlCeReplication.CompressionLevel = 2;
            maSqlCeReplication.Synchronize();
        }

        public static DataSet SQLServerCompactEdition(string chaineConnexion, decimal prixMini, decimal prixMaxi)
        {
            DataSet monDataSet = new DataSet();

            SqlCeConnection maSqlCeConnection = new SqlCeConnection(chaineConnexion);
            maSqlCeConnection.Open();

            SqlCeCommand maSqlCeCommand = maSqlCeConnection.CreateCommand();
            maSqlCeCommand.CommandText = Properties.Resources.ListeLivres;
            maSqlCeCommand.CommandType = CommandType.Text;

            maSqlCeCommand.Parameters.AddWithValue("@PrixMini", prixMini);
            maSqlCeCommand.Parameters.AddWithValue("@PrixMaxi", prixMaxi);

            SqlCeDataAdapter monSqlCeDataAdapter = new SqlCeDataAdapter(maSqlCeCommand);
            monSqlCeDataAdapter.Fill(monDataSet, "ListeDesLivres");

            maSqlCeConnection.Close();

            return monDataSet;
        }
    }
}
